//+------------------------------------------------------------------+
//|                                                        Aroon.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red

extern string TimeFrame         = "Current time frame";
extern int  AroonPeriod         = 25;
extern bool alertsOn            = false;
extern bool alertsOn50CrossUp   = true;
extern bool alertsOn50CrossDown = true;
extern bool alertsOnCurrent     = true;
extern bool alertsMessage       = true;
extern bool alertsPushNotif     = false;
extern bool alertsSound         = false;
extern bool alertsEmail         = false;
extern bool alertsOnCrosses     = false;

//
//
//
//
//

double buffer1[];
double buffer2[];
double trend1[];
double trend2[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,buffer1); SetIndexLabel(0,"Aroon Up");
   SetIndexBuffer(1,buffer2); SetIndexLabel(1,"Aroon Down");
   SetIndexBuffer(2,trend1);
   SetIndexBuffer(3,trend2);

      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //

   IndicatorShortName(timeFrameToString(timeFrame)+" Aroon ("+AroonPeriod+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=Bars-counted_bars;
           if (returnBars) { buffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (timeFrame!=Period())
   {
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for(int i=limit; i>=0; i--)
      {
       int y = iBarShift(NULL,timeFrame,Time[i]);               
          buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AroonPeriod,alertsOn,alertsOn50CrossUp,alertsOn50CrossDown,alertsOnCurrent,alertsMessage,alertsPushNotif,alertsSound,alertsEmail,alertsOnCrosses,0,y);
          buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",AroonPeriod,alertsOn,alertsOn50CrossUp,alertsOn50CrossDown,alertsOnCurrent,alertsMessage,alertsPushNotif,alertsSound,alertsEmail,alertsOnCrosses,1,y);
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      buffer1[i] = 100.0*(AroonPeriod-iHighest(NULL,0,MODE_HIGH,AroonPeriod+1,i)+i)/AroonPeriod;
      buffer2[i] = 100.0*(AroonPeriod- iLowest(NULL,0,MODE_LOW ,AroonPeriod+1,i)+i)/AroonPeriod;
      trend1[i] = trend1[i+1];
      trend2[i] = trend2[i+1];
      if (alertsOnCrosses)
      {
         if (buffer1[i]>buffer2[i]) trend1[i] =  1;
         if (buffer1[i]<buffer2[i]) trend1[i] = -1;
      }
      else
      {         
         if (buffer1[i]>50) trend1[i] =  1;
         if (buffer1[i]<50) trend1[i] = -1;
         if (buffer2[i]>50) trend2[i] =  1;
         if (buffer2[i]<50) trend2[i] = -1;
      }         
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static string   alertType1 = "";
      static datetime alertTime1 = 0;
         if (trend1[whichBar] != trend1[whichBar+1])
         {
            if (alertsOnCrosses)
            {
               if (alertsOn50CrossUp   && trend1[whichBar] ==  1) doAlert(alertType1,alertTime1,"Aroon up crossed Aroon down up");
               if (alertsOn50CrossDown && trend1[whichBar] == -1) doAlert(alertType1,alertTime1,"Aroon up crossed Aroon down down");
            }
            else
            {
               if (alertsOn50CrossUp   && trend1[whichBar] ==  1) doAlert(alertType1,alertTime1,"Aroon up crossed level 50 up");
               if (alertsOn50CrossDown && trend1[whichBar] == -1) doAlert(alertType1,alertTime1,"Aroon up crossed level 50 down");
            }               
         }
         static string   alertType2 = "";
         static datetime alertTime2 = 0;
         if (trend2[whichBar] != trend2[whichBar+1])
         {
            if (alertsOn50CrossUp   && trend2[whichBar] ==  1) doAlert(alertType2,alertTime2,"Aroon down crossed level 50 up");
            if (alertsOn50CrossDown && trend2[whichBar] == -1) doAlert(alertType2,alertTime2,"Aroon down crossed level 50 down");
         }
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(timeFrameToString(Period())," ",Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS),"  ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol(),"Aroon"),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol(),"Aroon "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}